stages:
  - fable
  - pages
  - build

fable:
  image: mcr.microsoft.com/dotnet/sdk:5.0-buster-slim
  stage: fable
  artifacts:
    paths:
      - yachtserver/WebRoot
  script:
    - apt update
    - apt install -y curl
    - curl -sL https://deb.nodesource.com/setup_14.x | bash -
    - apt install -y nodejs
    - npm install
    - dotnet tool restore
    - dotnet fable src/
    - npm run build-prod
    - npm run build-babel
    - cp -R yachtuwp/* yachtserver/WebRoot/
    - rm -rf yachtserver/WebRoot/lib
    - rm -rf yachtserver/WebRoot/images
    - rm yachtserver/WebRoot/index.html
    - rm yachtserver/WebRoot/package.appxmanifest
    - rm yachtserver/WebRoot/yachtuwp.jsproj

pages:
  image: alpine:3.14
  stage: pages
  needs: ["fable"]
  artifacts: 
    paths:
      - public
  script:
    - mkdir public
    - cp -R yachtserver/WebRoot/* public/
    - cd public
    - mv app.html index.html
#    - rm js/bundle.js
#    - mv js/legacy.js js/bundle.js
#    - rm js/startup.js
#    - echo "console.log('No service worker');" > js/startup.js


build:other:
  except:
    - dev
  image: docker:20.10.5
  stage: build
  needs: ["fable"]
  services:   
    - docker:19.03.12-dind
  variables:
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE_TAG ./yachtserver/
    - docker push $IMAGE_TAG

build:dev:
  only: 
    - dev
  image: docker:20.10.5
  stage: build
  needs: ["fable"]
  services:   
    - docker:19.03.12-dind
  variables:
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE_TAG ./yachtserver/
    - docker push $IMAGE_TAG
    - docker login -u $herokumail -p $herokukey registry.heroku.com
    - docker tag $IMAGE_TAG registry.heroku.com/modernyacht/web
    - docker push registry.heroku.com/modernyacht/web
